"IAL"

*
* Original Source File Name: d:\ial\procs\ihpib2.s
*

CONST_0034      CONSTANT 00000007FH
FMT_0000        FORMAT 8,HEX,2
FMT_0002        FORMAT 5,DEC,2
FMT_0004        FORMAT ASCII
        LABEL_TITLE      "          HP Inverse assembler for HPIB     "
        BASE_TITLE       "       ATN  Mnemonic  HEX EOI  SRQ  REN  IFC"
        DEFAULT_WIDTH    44
        MAPPED_WIDTH     44

ENTRY_POINT
    SET RETURN_FLAGS,1
    LOAD INPUT_STATUS
    POSITION ABS,42
    IF 3,3 = 0 THEN OUTPUT "IFC"
    POSITION ABS,8
    IF 0,0 = 0 THEN OUTPUT "ATN"
    POSITION ABS,27
    IF 1,1 = 0 THEN OUTPUT "EOI"
    POSITION ABS,37
    IF 2,2 = 0 THEN OUTPUT "REN"
    POSITION ABS,32
    IF 4,4 = 0 THEN OUTPUT "SRQ"
    POSITION ABS,23
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_0000    * 8,HEX,2
    POSITION ABS,13
    LOAD INPUT_STATUS
    CASE_OF 1,0
        OUTPUT "PAR POLL"
        CALL LABEL_0022
        CALL LABEL_005F
        CALL LABEL_0022
    CASE_END
    RETURN

LABEL_0022
    LOAD INPUT_DATA
    POSITION ABS,1
    IF 7,0 > 00000007FH THEN OUTPUT "MSB set"
    AND CONST_0034
    POSITION ABS,13
    IF 6,0 > 31 THEN GOTO LABEL_0050
    POSITION REL,1
    CASE_OF 4,0
        OUTPUT "<NUL>"
        OUTPUT "<SOH>"
        OUTPUT "<STX>"
        OUTPUT "<ETX>"
        OUTPUT "<EOT>"
        OUTPUT "<ENQ>"
        OUTPUT "<ACK>"
        OUTPUT "<BEL>"
        OUTPUT "<BS >"
        OUTPUT "<HT >"
        OUTPUT "<LF >"
        OUTPUT "<VT >"
        OUTPUT "<FF >"
        OUTPUT "<CR >"
        OUTPUT "<SO >"
        OUTPUT "<SI >"
        OUTPUT "<DLE>"
        OUTPUT "<DC1>"
        OUTPUT "<DC2>"
        OUTPUT "<DC3>"
        OUTPUT "<DC4>"
        OUTPUT "<NAK>"
        OUTPUT "<SYN>"
        OUTPUT "<ETB>"
        OUTPUT "<CAN>"
        OUTPUT "<EM >"
        OUTPUT "<SUB>"
        OUTPUT "<ESC>"
        OUTPUT "<FS >"
        OUTPUT "<GS >"
        OUTPUT "<RS >"
        OUTPUT "<US >"
    CASE_END
    RETURN

LABEL_0050
    IF 6,0 <> 32 THEN GOTO LABEL_0056
    POSITION REL,1
    OUTPUT "space"
    RETURN

LABEL_0056
    IF 6,0 <> 00000007FH THEN GOTO LABEL_005C
    POSITION REL,1
    OUTPUT "<DEL>"
    RETURN

LABEL_005C
    POSITION REL,3
    OUTPUT ACCUMULATOR,FMT_0004    * ASCII
    RETURN

LABEL_005F
    LOAD INPUT_DATA
    AND CONST_0034
    CASE_OF 6,4
        CALL LABEL_006C
        CALL LABEL_0083
        CALL LABEL_009A
        CALL LABEL_009A
        CALL LABEL_00A3
        CALL LABEL_00A3
        CALL LABEL_00AC
        CALL LABEL_00AC
    CASE_END
    RETURN

LABEL_006C
    CASE_OF 3,0
        GOTO LABEL_007F
        OUTPUT "  GTL"
        GOTO LABEL_007F
        GOTO LABEL_007F
        OUTPUT "  SDC"
        OUTPUT "  PPC"
        GOTO LABEL_007F
        GOTO LABEL_007F
        OUTPUT "  GET"
        OUTPUT "  TCT"
        GOTO LABEL_007F
        GOTO LABEL_007F
        GOTO LABEL_007F
        GOTO LABEL_007F
        GOTO LABEL_007F
        GOTO LABEL_007F
    CASE_END
    RETURN

LABEL_007F
    OUTPUT "ACG ["
    OUTPUT ACCUMULATOR,FMT_0000    * 8,HEX,2
    OUTPUT "]"
    RETURN

LABEL_0083
    CASE_OF 3,0
        GOTO LABEL_0096
        OUTPUT "  LLO"
        GOTO LABEL_0096
        GOTO LABEL_0096
        OUTPUT "  DCL"
        OUTPUT "  PPU"
        GOTO LABEL_0096
        GOTO LABEL_0096
        OUTPUT "  SPE"
        OUTPUT "  SPD"
        GOTO LABEL_0096
        GOTO LABEL_0096
        GOTO LABEL_0096
        GOTO LABEL_0096
        GOTO LABEL_0096
        GOTO LABEL_0096
    CASE_END
    RETURN

LABEL_0096
    OUTPUT "UCG ["
    OUTPUT ACCUMULATOR,FMT_0000    * 8,HEX,2
    OUTPUT "]"
    RETURN

LABEL_009A
    AND 31
    IF 4,0 <> 31 THEN GOTO LABEL_00A0
    OUTPUT " *UNL* "
    RETURN

LABEL_00A0
    OUTPUT " LAG_"
    OUTPUT ACCUMULATOR,FMT_0002    * 5,DEC,2
    RETURN

LABEL_00A3
    AND 31
    IF 4,0 <> 31 THEN GOTO LABEL_00A9
    OUTPUT " *UNT* "
    RETURN

LABEL_00A9
    OUTPUT " TAG_"
    OUTPUT ACCUMULATOR,FMT_0002    * 5,DEC,2
    RETURN

LABEL_00AC
    OUTPUT "SCG ["
    OUTPUT ACCUMULATOR,FMT_0000    * 8,HEX,2
    OUTPUT "]"
    RETURN
