"IAL"

*
* Original Source File Name: d:\ial\procs\irs232.s
*

FMT_0000        FORMAT 8,HEX,2
FMT_0002        FORMAT ASCII
        LABEL_TITLE      "   HP inverse assembler for RS232   "
        BASE_TITLE       " PIN  DATA  HEX  RTS CTS DTR DSR CD "
        DEFAULT_WIDTH    36
        MAPPED_WIDTH     36

ENTRY_POINT
    SET RETURN_FLAGS,1
    LOAD INPUT_STATUS
    POSITION ABS,34
    IF 7,7 = 1 THEN OUTPUT "CD"
    POSITION ABS,30
    IF 4,4 = 0 THEN OUTPUT "DSR"
    POSITION ABS,26
    IF 6,6 = 0 THEN OUTPUT "DTR"
    POSITION ABS,22
    IF 3,3 = 0 THEN OUTPUT "CTS"
    POSITION ABS,18
    IF 5,5 = 0 THEN OUTPUT "RTS"
    POSITION ABS,2
    IF 0,0 = 0 THEN OUTPUT "[2]"
    IF 0,0 = 1 THEN OUTPUT "[3]"
    CASE_OF 2,1
        GOTO LABEL_0023
        GOTO LABEL_0169
        GOTO LABEL_0062
        GOTO LABEL_0023
    CASE_END

LABEL_0023
    POSITION ABS,9
    LOAD INPUT_DATA
    IF 6,0 < 32 THEN GOTO LABEL_003C
    IF 6,0 = 00000007FH THEN GOTO LABEL_0037
    IF 6,0 = 32 THEN GOTO LABEL_0032
    OUTPUT ACCUMULATOR,FMT_0002    * ASCII
    POSITION ABS,13
    OUTPUT ACCUMULATOR,FMT_0000    * 8,HEX,2
    RETURN

LABEL_0032
    POSITION ABS,7
    OUTPUT "space"
    POSITION ABS,13
    OUTPUT ACCUMULATOR,FMT_0000    * 8,HEX,2
    RETURN

LABEL_0037
    POSITION ABS,7
    OUTPUT "<DEL>"
    POSITION ABS,13
    OUTPUT ACCUMULATOR,FMT_0000    * 8,HEX,2
    RETURN

LABEL_003C
    POSITION ABS,13
    OUTPUT ACCUMULATOR,FMT_0000    * 8,HEX,2
    POSITION ABS,7
    CASE_OF 4,0
        OUTPUT "<NUL>"
        OUTPUT "<SOH>"
        OUTPUT "<STX>"
        OUTPUT "<ETX>"
        OUTPUT "<EOT>"
        OUTPUT "<ENQ>"
        OUTPUT "<ACK>"
        OUTPUT "<BEL>"
        OUTPUT "<BS >"
        OUTPUT "<HT >"
        OUTPUT "<LF >"
        OUTPUT "<VT >"
        OUTPUT "<FF >"
        OUTPUT "<CR >"
        OUTPUT "<SO >"
        OUTPUT "<SI >"
        OUTPUT "<DLE>"
        OUTPUT "<DC1>"
        OUTPUT "<DC2>"
        OUTPUT "<DC3>"
        OUTPUT "<DC4>"
        OUTPUT "<NAK>"
        OUTPUT "<SYN>"
        OUTPUT "<ETB>"
        OUTPUT "<CAN>"
        OUTPUT "<EM >"
        OUTPUT "<SUB>"
        OUTPUT "<ESC>"
        OUTPUT "<FS >"
        OUTPUT "<GS >"
        OUTPUT "<RS >"
        OUTPUT "<US >"
    CASE_END
    RETURN

LABEL_0062
    LOAD INPUT_DATA
    POSITION ABS,13
    OUTPUT ACCUMULATOR,FMT_0000    * 8,HEX,2
    POSITION ABS,7
    CASE_OF 7,0
        OUTPUT "<NUL>"
        OUTPUT "<SOH>"
        OUTPUT "<STX>"
        OUTPUT "<ETX>"
        OUTPUT "<PF >"
        OUTPUT "<HT >"
        OUTPUT "<LC >"
        OUTPUT "<DEL>"
        OUTPUT " 08H "
        OUTPUT "<RLF>"
        OUTPUT "<SMM>"
        OUTPUT "<VT >"
        OUTPUT "<FF >"
        OUTPUT "<CR >"
        OUTPUT "<S0 >"
        OUTPUT "<SI >"
        OUTPUT "<DLE>"
        OUTPUT "<DC1>"
        OUTPUT "<DC2>"
        OUTPUT "<DC3>"
        OUTPUT "<RES>"
        OUTPUT "<NL >"
        OUTPUT "<BS >"
        OUTPUT "<IL >"
        OUTPUT "<CAN>"
        OUTPUT "<EM >"
        OUTPUT "<CC >"
        OUTPUT "<CU1>"
        OUTPUT "<IFS>"
        OUTPUT "<IGS>"
        OUTPUT "<IRS>"
        OUTPUT "<IUS>"
        OUTPUT "<DS >"
        OUTPUT "<SOS>"
        OUTPUT "<FS >"
        OUTPUT " 23H "
        OUTPUT "<BYP>"
        OUTPUT "<LF >"
        OUTPUT "<ETB>"
        OUTPUT "<ESC>"
        OUTPUT " 28H "
        OUTPUT " 29H "
        OUTPUT "<SM >"
        OUTPUT "<CU2>"
        OUTPUT " 2CH "
        OUTPUT "<ENQ>"
        OUTPUT "<ACK>"
        OUTPUT "<BEL>"
        OUTPUT " 30H "
        OUTPUT " 31H "
        OUTPUT "<SYN>"
        OUTPUT " 33H "
        OUTPUT "<PN >"
        OUTPUT "<RS >"
        OUTPUT "<UC >"
        OUTPUT "<EOT>"
        OUTPUT " 38H "
        OUTPUT " 39H "
        OUTPUT " 3AH "
        OUTPUT "<CU3>"
        OUTPUT "<DC4>"
        OUTPUT "<NAK>"
        OUTPUT " 3EH "
        OUTPUT "<SUB>"
        OUTPUT "space"
        OUTPUT " 41H "
        OUTPUT " 42H "
        OUTPUT " 43H "
        OUTPUT " 44H "
        OUTPUT " 45H "
        OUTPUT " 46H "
        OUTPUT " 47H "
        OUTPUT " 48H "
        OUTPUT " 49H "
        OUTPUT "<CNT>"
        OUTPUT "  .  "
        OUTPUT "  <  "
        OUTPUT "  (  "
        OUTPUT "  +  "
        OUTPUT "  !  "
        OUTPUT "  &  "
        OUTPUT " 51H "
        OUTPUT " 52H "
        OUTPUT " 53H "
        OUTPUT " 54H "
        OUTPUT " 55H "
        OUTPUT " 56H "
        OUTPUT " 57H "
        OUTPUT " 58H "
        OUTPUT " 59H "
        OUTPUT "  !  "
        OUTPUT "  $  "
        OUTPUT "  *  "
        OUTPUT "  )  "
        OUTPUT "  ;  "
        OUTPUT "<NOT>"
        OUTPUT "  -  "
        OUTPUT "  /  "
        OUTPUT " 62H "
        OUTPUT " 63H "
        OUTPUT " 64H "
        OUTPUT " 65H "
        OUTPUT " 66H "
        OUTPUT " 67H "
        OUTPUT " 68H "
        OUTPUT " 69H "
        OUTPUT "  |  "
        OUTPUT "  ,  "
        OUTPUT "  %  "
        OUTPUT "  -  "
        OUTPUT "  >  "
        OUTPUT "  ?  "
        OUTPUT " 70H "
        OUTPUT " 71H "
        OUTPUT " 72H "
        OUTPUT " 73H "
        OUTPUT " 74H "
        OUTPUT " 75H "
        OUTPUT " 76H "
        OUTPUT " 77H "
        OUTPUT " 78H "
        OUTPUT "  '  "
        OUTPUT "  :  "
        OUTPUT "  #  "
        OUTPUT "  @  "
        OUTPUT "  '  "
        OUTPUT "  =  "
        OUTPUT '  "  '
        OUTPUT " 80H "
        OUTPUT "  a  "
        OUTPUT "  b  "
        OUTPUT "  c  "
        OUTPUT "  d  "
        OUTPUT "  e  "
        OUTPUT "  f  "
        OUTPUT "  g  "
        OUTPUT "  h  "
        OUTPUT "  i  "
        OUTPUT " 8AH "
        OUTPUT " 8BH "
        OUTPUT " 8CH "
        OUTPUT " 8DH "
        OUTPUT " 8EH "
        OUTPUT " 8FH "
        OUTPUT " 90H "
        OUTPUT "  j  "
        OUTPUT "  k  "
        OUTPUT "  l  "
        OUTPUT "  m  "
        OUTPUT "  n  "
        OUTPUT "  o  "
        OUTPUT "  p  "
        OUTPUT "  q  "
        OUTPUT "  r  "
        OUTPUT " 99H "
        OUTPUT " 9AH "
        OUTPUT " 9BH "
        OUTPUT " 9CH "
        OUTPUT " 9DH "
        OUTPUT " 9FH "
        OUTPUT "0A0H "
        OUTPUT "  ~  "
        OUTPUT "  s  "
        OUTPUT "  t  "
        OUTPUT "  u  "
        OUTPUT "  v  "
        OUTPUT "  w  "
        OUTPUT "  x  "
        OUTPUT "  y  "
        OUTPUT "  z  "
        OUTPUT "0AAH "
        OUTPUT "0ABH "
        OUTPUT "0ACH "
        OUTPUT "0ADH "
        OUTPUT "0AEH "
        OUTPUT "0AFH "
        OUTPUT "0B0H "
        OUTPUT "0B1H "
        OUTPUT "0B2H "
        OUTPUT "0B3H "
        OUTPUT "0B4H "
        OUTPUT "0B5H "
        OUTPUT "0B6H "
        OUTPUT "0B7H "
        OUTPUT "0B8H "
        OUTPUT "0B9H "
        OUTPUT "0BAH "
        OUTPUT "0BBH "
        OUTPUT "0BCH "
        OUTPUT "0BDH "
        OUTPUT "0BEH "
        OUTPUT "0BFH "
        OUTPUT "  {  "
        OUTPUT "  A  "
        OUTPUT "  B  "
        OUTPUT "  C  "
        OUTPUT "  D  "
        OUTPUT "  E  "
        OUTPUT "  F  "
        OUTPUT "  G  "
        OUTPUT "  H  "
        OUTPUT "  I  "
        OUTPUT "0CAH "
        OUTPUT "0CBH "
        OUTPUT "0CCH "
        OUTPUT "0CDH "
        OUTPUT "0CEH "
        OUTPUT "0CFH "
        OUTPUT "  }  "
        OUTPUT "  J  "
        OUTPUT "  K  "
        OUTPUT "  L  "
        OUTPUT "  M  "
        OUTPUT "  N  "
        OUTPUT "  O  "
        OUTPUT "  P  "
        OUTPUT "  Q  "
        OUTPUT "  R  "
        OUTPUT "0DAH "
        OUTPUT "0DBH "
        OUTPUT "0DCH "
        OUTPUT "0DDH "
        OUTPUT "0DEH "
        OUTPUT "0DFH "
        OUTPUT "  \  "
        OUTPUT "0E1H "
        OUTPUT "  S  "
        OUTPUT "  T  "
        OUTPUT "  U  "
        OUTPUT "  V  "
        OUTPUT "  W  "
        OUTPUT "  X  "
        OUTPUT "  Y  "
        OUTPUT "  Z  "
        OUTPUT "0EAH "
        OUTPUT "0EBH "
        OUTPUT "0ECH "
        OUTPUT "0EDH "
        OUTPUT "0EEH "
        OUTPUT "0EFH "
        OUTPUT "  0  "
        OUTPUT "  1  "
        OUTPUT "  2  "
        OUTPUT "  3  "
        OUTPUT "  4  "
        OUTPUT "  5  "
        OUTPUT "  6  "
        OUTPUT "  7  "
        OUTPUT "  8  "
        OUTPUT "  9  "
        OUTPUT "0FAH "
        OUTPUT "0FBH "
        OUTPUT "0FCH "
        OUTPUT "0FDH "
        OUTPUT "0FEH "
        OUTPUT "0FFH "
    CASE_END
    RETURN

LABEL_0169
    LOAD INPUT_DATA
    POSITION ABS,13
    OUTPUT ACCUMULATOR,FMT_0000    * 8,HEX,2
    POSITION ABS,7
    CASE_OF 5,0
        OUTPUT "<SOH>"
        OUTPUT "  A  "
        OUTPUT "  B  "
        OUTPUT "  C  "
        OUTPUT "  D  "
        OUTPUT "  E  "
        OUTPUT "  F  "
        OUTPUT "  G  "
        OUTPUT "  H  "
        OUTPUT "  I  "
        OUTPUT "<STX>"
        OUTPUT "  .  "
        OUTPUT "  <  "
        OUTPUT "<BEL>"
        OUTPUT "<SUB>"
        OUTPUT "<ETB>"
        OUTPUT "  &  "
        OUTPUT "  J  "
        OUTPUT "  K  "
        OUTPUT "  L  "
        OUTPUT "  M  "
        OUTPUT "  N  "
        OUTPUT "  O  "
        OUTPUT "  P  "
        OUTPUT "  Q  "
        OUTPUT "  R  "
        OUTPUT "space"
        OUTPUT "  $  "
        OUTPUT "  *  "
        OUTPUT "<US >"
        OUTPUT "<EOT>"
        OUTPUT "<DLE>"
        OUTPUT "  -  "
        OUTPUT "  /  "
        OUTPUT "  S  "
        OUTPUT "  T  "
        OUTPUT "  U  "
        OUTPUT "  V  "
        OUTPUT "  W  "
        OUTPUT "  X  "
        OUTPUT "  Y  "
        OUTPUT "  Z  "
        OUTPUT "<ESC>"
        OUTPUT "  ,  "
        OUTPUT "  %  "
        OUTPUT "<ENQ>"
        OUTPUT "<ETX>"
        OUTPUT "<HT >"
        OUTPUT "  0  "
        OUTPUT "  1  "
        OUTPUT "  2  "
        OUTPUT "  3  "
        OUTPUT "  4  "
        OUTPUT "  5  "
        OUTPUT "  6  "
        OUTPUT "  7  "
        OUTPUT "  8  "
        OUTPUT "  9  "
        OUTPUT "<SYN>"
        OUTPUT "  #  "
        OUTPUT "  @  "
        OUTPUT "<NAK>"
        OUTPUT "<EM >"
        OUTPUT "<DEL>"
    CASE_END
    RETURN
